import falcon

from restapi import settings
from restapi.middleware import debug
from restapi.urls import setup_routes
from restapi.utils.errors import handler
from restapi.utils.logs import get_logger

_LOG = get_logger()

middleware = [
    #handle_404.WrongURL()
]
if settings.DEBUG:
    middleware.append(debug.LogRequestResponse())

# Create the API instance, referenced internally as api and externally as
# wsgi_app
api = falcon.API(
    media_type='application/json',
    middleware=middleware
)

api.add_error_handler(Exception, handler)
setup_routes(api)
_LOG.info('API service started')
