import json
import subprocess

import falcon
import six

from restapi.utils import config
from restapi.utils.logs import get_logger

if six.PY3:
    import asyncio

_LOG = get_logger()
_shell = None


class _Shell27(object):

    def __init__(self, root_helper):
        self.root_helper = root_helper

    def __call__(self, args):
        if isinstance(args, str):
            args = args.split()
        process = subprocess.Popen([self.root_helper] + args,
                                   stdout=subprocess.PIPE,
                                   stderr=subprocess.STDOUT)
        stdout, _ = process.communicate()
        return stdout, process.returncode


class _Shell(object):

    def __init__(self, root_helper):
        self.root_helper = root_helper

    def __call__(self, args):
        if six.PY3():
            loop = asyncio.get_event_loop()
            return loop.run_until_complete(self.exec_command(args))
        else:
            if isinstance(args, str):
                args = args.split()
            process = subprocess.Popen([self.root_helper] + args,
                                       stdout=subprocess.PIPE,
                                       stderr=subprocess.STDOUT)
            stdout, _ = process.communicate()
            return stdout, process.returncode

    def exec_command(self, args):
        pass
        # if isinstance(args, str):
        #     args = args.split()
        # process = yield from asyncio.create_subprocess_exec(
        #         *([self.root_helper] + args),
        #         stdout=subprocess.PIPE,
        #         stderr=subprocess.STDOUT
        # )
        # stdout, _ = yield from process.communicate()
        # return stdout, process.returncode

if six.PY3:
    _Shell.exec_command = asyncio.coroutine(_Shell.exec_command)


def execute_command(cmd, resp):
    """ error: stderr if unsuccessful
               type: string
               optional: yes
        output: stdout of the command if successful
                type: string
                optional: yes
    """
    global _shell
    _shell = _shell or _Shell27(config.get_root_helper())
    _LOG.debug('Executing %s', cmd)
    output, retcode = _shell(cmd)
    _LOG.debug('Return code %s, output %s', retcode, output)
    # cmd_response = CommandResponse()
    # cmd_response.code = retcode
    # cmd_response.message = output
    resp.status = falcon.HTTP_200
    # cmd_response.type = 'stdout'
    if retcode != 0:
        resp.status = falcon.HTTP_500
        _LOG.error('Command failed. out:%s', output)
        # cmd_response.type = 'stderr'
    try:
        resp.body = json.dumps(output)
    except Exception:
        resp.body = output
