# vim: tabstop=4 shiftwidth=4 softtabstop=4
# Copyright 2016 Cumulus Networks, Inc. All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc.
# 51 Franklin Street, Fifth Floor
# Boston, MA  02110-1301, USA.
from __future__ import absolute_import

from restapi.utils.urls import patterns, url


urlpatterns = patterns(
    'restapi.apps.netq',

    # Models
    url('models/', 'queries.Models', 'models'),
    url('models/{modelName}/all', 'queries.QueryAll', 'queryAll'),
    url('models/{modelName}/count', 'queries.QueryCount', 'queryCount'),
    url('models/{modelName}/delete', 'queries.QueryDelete', 'queryDelete'),
    url('models/{modelName}/filter', 'queries.QueryFilter', 'queryFilter'),
    url('models/{modelName}/get', 'queries.QueryGet', 'queryGet'),
    url('models/{modelName}/lpm', 'queries.QueryLpm', 'queryLpm'),
    url('models/{modelName}/range', 'queries.QueryRange', 'queryRange'),
    url('models/{modelName}/rangeByScore', 'queries.QueryRangeByScore',
        'queryRangeByScore'),
)
