import json

import falcon
from restapi import settings


class WrongURL(object):

    def process_response(self, req, resp, resource=''):
        """ Intercept main 404 response by Falcon
        If the API hits a non existing endpoint, it will trigger a customized
        404 response that will redirect people to the documentation.
        :returns: JSON: A customized JSON response
        :raises: HTTP 404: A falcon.HTTP_404 error
        """
        if resp.status == falcon.HTTP_404:
            resp.body = json.dumps({
                "message": "Not found",
                "documentation": settings.__docs__
            })