import falcon

from restapi.utils.logs import get_logger


_LOG = get_logger()


def handler(ex, req, resp, _):
    if not isinstance(ex, falcon.HTTPError):
        _LOG.exception('Error processing request to URL %s with params %s',
                       req.url, req.params)
    response = {
        'message': "Error processing request."
    }
    if hasattr(ex, 'description'):
        response['description'] = str(ex.description.strip('\n'))
    elif hasattr(ex, 'message'):
        response['message'] = str(ex.message)
    resp.status = falcon.HTTP_500
