import logging
import logging.config

from oslo.config import cfg

from restapi import settings

_DEFAULT_LOGGER = 'restapi'


def setup_logging():
    """ Sets up the logging options for a log.
    """
    log_config = settings.LOG_CONFIG
    log_config['loggers'][_DEFAULT_LOGGER]['level'] = cfg.CONF.LOGGING.loglevel
    if cfg.CONF.LOGGING.logpath == 'syslog':
        log_config['loggers'][_DEFAULT_LOGGER]['handlers'] = ['syslog']
    else:
        log_config['loggers'][_DEFAULT_LOGGER]['handlers'] = ['logfile']
        log_config['handlers']['logfile']['filename'] = (
            cfg.CONF.LOGGING.logpath
        )
    logging.config.dictConfig(log_config)


def get_logger():
    return logging.getLogger(_DEFAULT_LOGGER)
